import lexer_example
@with_lexer(foo_lexer)
grammar foo_grammar {
    name <- Name(@identifier)
    @main_rule main_rule <- list+(or(Definition("def" name) | name), ",")

}

@abstract class FooNode : Node {
}

class Definition : FooNode {
    @parse_field name : Name
}

class Name : FooNode implements TokenNode {
    ref_var : LogicVar

    @export fun resolve (): Bool = {
        val candidates = node.node_env().get(node).map((d) => d.as[Definition]);

        %domain(node.ref_var, candidates).solve()
    }

    @export fun definition (): Definition =
    node.ref_var.get_value().as[Definition]
}
